"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var index_1 = require("bitfront-library/shared/index");
var CampanyaService = (function () {
    function CampanyaService(http, message, utils) {
        this.http = http;
        this.message = message;
        this.utils = utils;
        this.baseUrl = 'v1/campanyas';
        console.log("CampanyaService construido");
    }
    CampanyaService.prototype.findCampanya = function (referencia) {
        var url = this.baseUrl + "/" + referencia
            + "/?idioma=" + '' + index_1.Idioma.getCodigo();
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findServicios = function (referencia) {
        var url = this.baseUrl + '/' + referencia + '/servicios'
            + '?idioma=' + index_1.Idioma.getCodigo();
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findServicio = function (referencia, servicioId) {
        var url = 'v1/campanyas/' + referencia + '/servicios/' + servicioId
            + '?idioma=' + index_1.Idioma.getCodigo();
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findSitios = function (referencia) {
        var url = 'v1/campanyas/' + referencia + '/sitios'
            + '?idioma=' + index_1.Idioma.getCodigo();
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findEntidades = function (referencia, servicioId, sitioId) {
        var url = 'v1/campanyas/' + referencia + '/entidades'
            + '?idioma=' + index_1.Idioma.getCodigo()
            + '&servicio=' + servicioId + '&sitio=' + sitioId + '&huecos_libres=S';
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findRecursosDeEntidad = function (referencia, entidadId, servicioId) {
        var url = 'v1/campanyas/' + referencia + '/entidades/' + entidadId + "/recursos"
            + '?idioma=' + index_1.Idioma.getCodigo();
        if (servicioId) {
            url += '&servicio=' + servicioId;
        }
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findCamposDeServicio = function (referencia, servicioId) {
        var url = 'v1/campanyas/' + referencia + '/servicios/' + servicioId + '/campos_solicitante'
            + '?idioma=' + index_1.Idioma.getCodigo();
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findPrimerDiaHoraDisponible = function (referencia, servicioId, entidadId, sitioId, recursoId) {
        var url = 'v1/campanyas/' + referencia + '/primer_dia_hora_disponible'
            + '?idioma=' + index_1.Idioma.getCodigo();
        if (servicioId) {
            url += '&servicio=' + servicioId;
        }
        if (entidadId) {
            url += '&entidad=' + entidadId;
        }
        if (sitioId) {
            url += '&sitio=' + sitioId;
        }
        if (recursoId) {
            url += '&recurso=' + recursoId;
        }
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findDiasDisponibles = function (referencia, servicioId, entidadId, sitioId, recursoId) {
        var url = 'v1/campanyas/' + referencia + '/dias_disponibles'
            + '?idioma=' + index_1.Idioma.getCodigo();
        if (servicioId) {
            url += '&servicio=' + servicioId;
        }
        if (entidadId) {
            url += '&entidad=' + entidadId;
        }
        if (sitioId) {
            url += '&sitio=' + sitioId;
        }
        if (recursoId) {
            url += '&recurso=' + recursoId;
        }
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.findHorasDisponibles = function (dia, referencia, servicioId, entidadId, sitioId, recursoId) {
        var url = 'v1/campanyas/' + referencia + '/horas_disponibles'
            + '?idioma=' + index_1.Idioma.getCodigo();
        if (dia) {
            url += '&dia=' + dia;
        }
        if (servicioId) {
            url += '&servicio=' + servicioId;
        }
        if (entidadId) {
            url += '&entidad=' + entidadId;
        }
        if (sitioId) {
            url += '&sitio=' + sitioId;
        }
        if (recursoId) {
            url += '&recurso=' + recursoId;
        }
        return this.http.getHttpGet(url);
    };
    CampanyaService.prototype.resendSmsCita = function (referencia, nif, telefono) {
        var url = 'v1/campanyas/' + referencia + '/citas'
            + '?idioma=' + index_1.Idioma.getCodigo()
            + '&nif=' + nif
            + '&telefono=' + telefono;
        return this.http.getHttpGet(url);
    };
    CampanyaService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    CampanyaService.ctorParameters = function () { return [
        { type: index_1.HttpUtilsService, },
        { type: index_1.MessageService, },
        { type: index_1.GeneralUtils, },
    ]; };
    return CampanyaService;
}());
exports.CampanyaService = CampanyaService;
//# sourceMappingURL=campanya.service.js.map