"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@ngx-translate/core");
var index_1 = require("bitfront-library/shared/index");
var campanya_service_1 = require("../../common/service/campanya.service");
var reservar_cita_paso_1 = require("./reservar-cita-paso");
var SeleccionarServicioComponent = (function (_super) {
    __extends(SeleccionarServicioComponent, _super);
    function SeleccionarServicioComponent(campanyaService, translate, message) {
        var _this = _super.call(this, "SeleccionarServicioComponent") || this;
        _this.campanyaService = campanyaService;
        _this.translate = translate;
        _this.message = message;
        return _this;
    }
    /// Comportamiento general del paso (sobrescribe lo definido en ReservaCitaPaso) ///
    SeleccionarServicioComponent.prototype.loadDatosInicio = function () {
        var _this = this;
        this.campanyaService.findServicios(this.peticion.referencia).subscribe(function (result) { _this.listServicio = index_1.GeneralUtils.addOpcionVacia(result); });
        this.campanyaService.findSitios(this.peticion.referencia).subscribe(function (result) { _this.listSitio = index_1.GeneralUtils.addOpcionVacia(result); });
        this.loadEntidades();
    };
    SeleccionarServicioComponent.prototype.validarPaso = function () {
        var _this = this;
        if (this.peticion.servicioId && this.peticion.sitioId && this.peticion.entidadId) {
            return true;
        }
        else {
            this.translate.get("error.servicioSitioEntidad").subscribe(function (result) {
                var err = new index_1.Error(null, index_1.Idioma.esCatalanSeleccionado() ? result : null, index_1.Idioma.esEspanyolSeleccionado() ? result : null, null, true);
                _this.message.sendError(err);
            });
        }
    };
    SeleccionarServicioComponent.prototype.updateReservaCita = function () {
        if (this.listServicio) {
            this.resumen.servicioNombre = index_1.GeneralUtils.getOptionText(this.listServicio, this.peticion.servicioId);
        }
        if (this.listSitio) {
            this.resumen.sitioNombre = index_1.GeneralUtils.getOptionText(this.listSitio, this.peticion.sitioId);
        }
        if (this.listEntidad) {
            this.resumen.entidadNombre = index_1.GeneralUtils.getOptionText(this.listEntidad, this.peticion.entidadId);
        }
        if (this.listRecurso) {
            this.resumen.recursoNombre = index_1.GeneralUtils.getOptionText(this.listRecurso, this.peticion.recursoId);
        }
    };
    SeleccionarServicioComponent.prototype.resetActions = function () {
        this.peticion.servicioId = null; // Es necesario hacer esto aquí porque la propagación desde el componente padre no llega a tiempo
        this.listEntidad = null;
        this.listRecurso = null;
        this.loadEntidades();
    };
    SeleccionarServicioComponent.prototype.back = function () {
        window.history.back();
    };
    /// Comportamiento propio de este paso ///
    SeleccionarServicioComponent.prototype.changeServicio = function () {
        var _this = this;
        if (this.peticion.servicioId) {
            this.campanyaService.findServicio(this.peticion.referencia, this.peticion.servicioId)
                .subscribe(function (result) {
                _this.resumen.servicio = result;
            });
            this.loadEntidades();
        }
    };
    SeleccionarServicioComponent.prototype.changeSitio = function () {
        this.loadEntidades();
    };
    SeleccionarServicioComponent.prototype.loadEntidades = function () {
        var _this = this;
        if (this.peticion.servicioId && this.peticion.sitioId) {
            this.campanyaService.findEntidades(this.peticion.referencia, this.peticion.servicioId, this.peticion.sitioId)
                .subscribe(function (result) { _this.listEntidad = index_1.GeneralUtils.addOpcionVacia(result); });
        }
        else {
            this.translate.get("info.seleccioneServicioSitio").subscribe(function (result) {
                _this.listEntidad = [new index_1.Domain(null, result)];
            });
        }
    };
    SeleccionarServicioComponent.prototype.changeEntidad = function () {
        var _this = this;
        if (this.peticion.entidadId && this.resumen.servicio.permiteSeleccionRecurso) {
            this.campanyaService.findRecursosDeEntidad(this.peticion.referencia, this.peticion.entidadId, this.peticion.servicioId)
                .subscribe(function (result) { _this.listRecurso = index_1.GeneralUtils.addOpcionVacia(result); });
        }
    };
    SeleccionarServicioComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bci-seleccionar-servicio',
                    template: "\n      <div class=\"paso\" [style.display]=\"visible?'block':'none'\">\n          <h4><span class=\"fa fa-check-square-o\"></span>&nbsp;&nbsp;<span translate=\"titulo.seleccionarServicio\">Introducció i selecció de servei</span></h4>\n          <!-- mlm bci-seleccionar-servicio-texto></bci-seleccionar-servicio-texto -->\n          <ng-content></ng-content>\n          <div class=\"row\">\n              <div class=\"col-sm-9 col-md-6\">\n                  <div class=\"form-group\">\n                      <label id=\"servicioLabel\" for=\"servicioId\" translate=\"seleccionar.servicio\">Seleccioni un servei</label>\n                      <p-dropdown id=\"servicioId\" [options]=\"listServicio\" [(ngModel)]=\"peticion.servicioId\" [autoWidth]=\"false\" (onChange)=\"changeServicio()\"></p-dropdown>\n                  </div>\n                  <div class=\"form-group\">\n                      <label id=\"sitioLabel\"    for=\"sitioId\"    translate=\"seleccionar.sitio\">Seleccioni un lloc</label>\n                      <p-dropdown id=\"sitioId\"    [options]=\"listSitio\"    [(ngModel)]=\"peticion.sitioId\"    [autoWidth]=\"false\" (onChange)=\"changeSitio   ()\"></p-dropdown>\n                  </div>\n                  <div class=\"form-group\">\n                      <label id=\"entidadLabel\"  for=\"entidadId\"  translate=\"seleccionar.entidad\">Seleccioni una oficina</label>\n                      <p-dropdown id=\"entidadId\"  [options]=\"listEntidad\"  [(ngModel)]=\"peticion.entidadId\"  [autoWidth]=\"false\" (onChange)=\"changeEntidad ()\"></p-dropdown>\n                  </div>\n                  <div *ngIf=\"listRecurso\" class=\"form-group\">\n                      <label id=\"recursoLabel\"  for=\"recursoId\"  translate=\"seleccionar.recurso\">Seleccioni un tècnic</label>\n                      <p-dropdown id=\"recursoId\"  [options]=\"listRecurso\"  [(ngModel)]=\"peticion.recursoId\"  [autoWidth]=\"false\"></p-dropdown>\n                  </div>\n              </div>\n          </div>\n          <div class=\"row\">\n              <div class=\"col-xs-12\">\n                  <div class=\"btn-navegar\">\n                      <button class=\"btn btn-default pull-left\"  (click)=\"back();\"><span class=\"fa fa-chevron-left\"></span>&nbsp;&nbsp;<span translate=\"btn.volver\">Tornar</span></button>\n                      <button class=\"btn btn-success pull-right\" (click)=\"goToPasoSiguiente();\"><span translate=\"btn.continuar\">Continua</span>&nbsp;&nbsp;<span class=\"fa fa-chevron-right\"></span></button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    SeleccionarServicioComponent.ctorParameters = function () { return [
        { type: campanya_service_1.CampanyaService, },
        { type: core_2.TranslateService, },
        { type: index_1.MessageService, },
    ]; };
    return SeleccionarServicioComponent;
}(reservar_cita_paso_1.ReservarCitaPaso));
exports.SeleccionarServicioComponent = SeleccionarServicioComponent;
//# sourceMappingURL=1-seleccionar-servicio.component.js.map