"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/of");
var core_2 = require("@ngx-translate/core");
var index_1 = require("bitfront-library/shared/index");
var custom_validators_service_1 = require("../../sharedbitcitaweb/service/custom-validators.service");
var campanya_service_1 = require("../../common/service/campanya.service");
var reservar_cita_paso_1 = require("./reservar-cita-paso");
var DatosPersonalesComponent = (function (_super) {
    __extends(DatosPersonalesComponent, _super);
    function DatosPersonalesComponent(campanyaService, formBuilder, translate, message) {
        var _this = _super.call(this, "DatosPersonalesComponent") || this;
        _this.campanyaService = campanyaService;
        _this.formBuilder = formBuilder;
        _this.translate = translate;
        _this.message = message;
        _this.validators = {
            "codigoAlfanumerico": custom_validators_service_1.CustomValidators.codigoAlfanumerico,
            "cp": custom_validators_service_1.CustomValidators.cp,
            "email": custom_validators_service_1.CustomValidators.email,
            "fecha": custom_validators_service_1.CustomValidators.fecha,
            "nif": custom_validators_service_1.CustomValidators.nifnie,
            "nombre": custom_validators_service_1.CustomValidators.nombre,
            "telefono": custom_validators_service_1.CustomValidators.telefono,
        };
        return _this;
    }
    /// Comportamiento general del paso (sobrescribe lo definido en ReservaCitaPaso) ///
    /** Cuando el usuario vuelve a esta pestaña y el servicio ha cambiado, hay que recargar la lista de campos. */
    /** Cuando el usuario vuelve a esta pestaña y el servicio ha cambiado, hay que recargar la lista de campos. */
    DatosPersonalesComponent.prototype.refreshDatosVisible = /** Cuando el usuario vuelve a esta pestaña y el servicio ha cambiado, hay que recargar la lista de campos. */
    function () {
        if (this.peticion.servicioId && this.servicioId !== this.peticion.servicioId) {
            this.servicioId = this.peticion.servicioId;
            this.loadCampos();
        }
    };
    DatosPersonalesComponent.prototype.validarPaso = function () {
        var _this = this;
        if (this.myForm.valid) {
            return true;
        }
        else {
            this.translate.get("error.datosPersonales").subscribe(function (result) {
                var err = new index_1.Error(null, index_1.Idioma.esCatalanSeleccionado() ? result : null, index_1.Idioma.esEspanyolSeleccionado() ? result : null, null, true);
                _this.message.sendError(err);
            });
        }
    };
    DatosPersonalesComponent.prototype.updateReservaCita = function () {
        if (this.listCampo) {
            this.peticion.setValores(this.listCampo);
        }
    };
    DatosPersonalesComponent.prototype.resetActions = function () {
        this.servicioId = null;
        this.listCampo = null;
    };
    /// Comportamiento propio de este paso ///
    DatosPersonalesComponent.prototype.loadCampos = function () {
        var _this = this;
        this.campanyaService.findCamposDeServicio(this.peticion.referencia, this.peticion.servicioId)
            .subscribe(function (result) {
            _this.listCampo = result;
            _this.buildFormGroup();
        });
    };
    /// Gestión de los formularios ///
    DatosPersonalesComponent.prototype.buildFormGroup = function () {
        var group = {};
        for (var i = 0; this.listCampo != null && i < this.listCampo.length; i++) {
            var campo = this.listCampo[i];
            var checks = campo.obligatorio ? [forms_1.Validators.required] : [];
            checks.push(this.validators[campo.checkForm]);
            group["cmp" + campo.campoId] = [this.listCampo[i].valor, checks];
        }
        this.myForm = this.formBuilder.group(group);
    };
    DatosPersonalesComponent.prototype.campoShowError = function (campoId) {
        var control = this.myForm.controls['cmp' + campoId];
        return control.invalid && control.touched;
    };
    DatosPersonalesComponent.prototype.campoError = function (campoId) {
        var control = this.myForm.controls['cmp' + campoId];
        if (control && control.errors && control.touched) {
            var error = null;
            for (var e in control.errors) {
                error = e;
                break;
            }
            return this.translate.get("error." + error);
        }
        else {
            return Observable_1.Observable.of(null);
        }
    };
    DatosPersonalesComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'bci-datos-personales',
                    template: "\n      <div class=\"paso\" [style.display]=\"visible?'block':'none'\">\n          <h4><span class=\"fa fa-user-circle-o\"></span>&nbsp;&nbsp;<span translate=\"titulo.introducirDatos\">Dades personals</span></h4>\n          <!--mlm bci-datos-personales-texto></bci-datos-personales-texto -->\n          <div class=\"row\">\n              <div class=\"col-sm-9 col-md-6\">\n                  <form *ngIf=\"myForm\" role=\"form\" [formGroup]=\"myForm\">\n                      <div class=\"form-group\" *ngFor=\"let campo of listCampo\">\n                          <label>{{campo.nombre}}</label>\n                          <input type=\"text\" class=\"form-control\" id=\"cmp{{campo.campoId}}\" [(ngModel)]=\"campo.valor\" formControlName=\"cmp{{campo.campoId}}\" />\n                          <span *ngIf=\"campoShowError(campo.campoId)\" class=\"texto-rojo\">Error: {{campoError(campo.campoId) | async}}</span>\n                      </div>\n                  </form>\n              </div>\n          </div>\n          <div *ngIf=\"resumen?.servicio?.smsNotificarReserva\" class=\"row\">\n              <div class=\"col-xs-12\">\n                  <div class=\"alert alert-warning\" translate=\"info.siQuiereSms\">\n                      (*) Si vol rebre la confirmació de la seva cita mitjantçant SMS, indiqui'ns el seu número de mòbil i estigui atent.\n                  </div>\n              </div>\n          </div>\n          <div class=\"row\">\n              <div class=\"col-xs-12\">\n                  <div class=\"btn-navegar\">\n                      <button class=\"btn btn-success pull-left\"  (click)=\"goToPasoAnterior ();\"><span class=\"fa fa-chevron-left\"></span>&nbsp;&nbsp;<span translate=\"btn.atras\">Enrere</span></button>\n                      <button class=\"btn btn-success pull-right\" (click)=\"goToPasoSiguiente();\"><span translate=\"btn.continuar\">Continua</span>&nbsp;&nbsp;<span class=\"fa fa-chevron-right\"></span></button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    "
                },] },
    ];
    /** @nocollapse */
    DatosPersonalesComponent.ctorParameters = function () { return [
        { type: campanya_service_1.CampanyaService, },
        { type: forms_1.FormBuilder, },
        { type: core_2.TranslateService, },
        { type: index_1.MessageService, },
    ]; };
    return DatosPersonalesComponent;
}(reservar_cita_paso_1.ReservarCitaPaso));
exports.DatosPersonalesComponent = DatosPersonalesComponent;
//# sourceMappingURL=2-datos-personales.component.js.map